from Calc_p_from_chi2 import calc_p

class Ccalc_chi2:
    def __init__(self, prop, obs):
        self.prop = prop
        self.obs = obs

    def calc(self):
        sump = 0.0
        for v in self.prop:
            sump += v
        prob = []
        for v in self.prop:
            prob.append(v / sump)

        N = 0
        for v in self.obs:
            N += v

        c = len(self.obs)
        df = c - 1
        E = []
        for i in range(0, c):
            E.append( prob[i] * N )

        print(" ")
        print("%10s"%"Obs.", "%10s"%"E")
        for i in range(0, c):
            print("%10d"%self.obs[i], "%10.2f"%E[i])
        print(" ")

        chi2 = 0.0
        for i in range(0, c):
            chi2 += ((self.obs[i] - E[i]) ** 2.0) / E[i]

        p = calc_p(chi2, df)

        return chi2, p, df
